/*
	FT245RL - 8254 Beep Sound Controller Header
	2016/02/21	Rei_Shinonome
	
	FT245RL Pin Assign

	DB0	:	Serial Data
	DB1	:	Serial Clock
	DB2	:	~WR for 8254
	DB3	:	A0 for 8254
	DB4	:	A1 for 8254
	DB5	:	GATE for 8254
	DB6	:	NC
	DB7	:	NC

	DB0 and DB1 should be connected to a certain SIPO shift register.
	Pararell Out of the shift register should be connected to 8254 D0-7.
	8254 ~RD is not used. It must be Inactive.

*/

/*
\

typedef struct{
	unsigned char low;		//8254^C}16bit݉ʃoCg
	unsigned char high;		//8254^C}16bitݏʃoCg
} D_8254;

typedef struct{
	FT_STATUS	ftStatus;	//FT245RLɑ΂鑀쌋
	DWORD	Flags;			//tOl
	DWORD	TypeFT;			//foCX^Cv
	DWORD	ID;			//device ID
	DWORD	LocId;			//device location ID
	char	SerialNumber[16];	//VAio[
	char	Description[64];	//foCX
	FT_HANDLE	ftHandle;	//foCXnh
} FT_STAT;

*/

/*
֐

FT_STAT InitFT245(	//FT245̏
	int BAUDRATE,	//]x
	int BITMODE,	//][h 0x1Ŕ񓯊Bit Bang Mode
	int MASK	//o͕ 0xFFőSo
);

void SetWrite(		//82541oCgn(GATEActivej
	int _org,	//݃f[^
	int _adr	//^C}̃`lERg[[h
);

void Send8254(		//^C}ւ2oCgA
	D_8254	_send	//8254ɏ2oCgf[^
	int	_addr	//^C}̃`l
);

*/


#include "ftd2xx.h"


typedef struct{
	unsigned char low;
	unsigned char high;
} D_8254;

typedef struct{
	FT_STATUS	ftStatus;
	DWORD	Flags;
	DWORD	TypeFT;
	DWORD	ID;
	DWORD	LocId;
	char	SerialNumber[16];
	char	Description[64];
	FT_HANDLE	ftHandle;
} FT_STAT;


	DWORD	numDevs;
	DWORD	BytesWritten;
	FT_STATUS	ftStatus;
	FT_HANDLE	ftHandle;

	FT_STAT InitFT245(int BAUDRATE, int BITMODE, int MASK){

		FT_STAT F_Stat;

		unsigned char InitFF[3] = {
			0xFF,
			0x24,
			0x04
		};


		F_Stat.ftStatus = FT_Open(0, &ftHandle);

		if (F_Stat.ftStatus != FT_OK){

			return F_Stat;

		}

		FT_CreateDeviceInfoList(&numDevs);
		FT_GetDeviceInfoDetail(0, &F_Stat.Flags, &F_Stat.TypeFT, &F_Stat.ID, &F_Stat.LocId, F_Stat.SerialNumber, F_Stat.Description, &F_Stat.ftHandle);
		FT_SetBaudRate(ftHandle, BAUDRATE);
		FT_SetBitMode(ftHandle, MASK, BITMODE);
		F_Stat.ftStatus = FT_Write(ftHandle, InitFF, sizeof(InitFF), &BytesWritten);

		return F_Stat;

	}

	void SetWrite(int _org, int _adr){

		int _temp1;			//f[^1Bito߂̍ƕϐ
		unsigned char wrBits[21];	//ރrbgB1oCgɂ21INebg

		_temp1 = _org ;		//f[^荞

		wrBits[0] = 0x24; //GATE ACTIVE, ADDR 0, WR INACTIVE, SC/SD 0
		wrBits[1] = 0x24; //GATE ACTIVE, ADDR 0, WR INACTIVE, SC/SD 0

		for(int i = 0; i < 8  ; i++){

			_temp1 = _temp1 & 0xFF;	//int^牺1oCgo

			_temp1 = _temp1 / 128;	//f[^̍ŏbit0/1ŎoB

			wrBits[(i+1)*2] = (_temp1) | ((_adr * 8) | 0x24);	//bit0Ƀf[^ŏʃrbgBbit3,4ɃAhXZbgB bit5(GATE)ON bit1(SC)L bit2(WR)Inactive
			wrBits[((i+1)*2)+1] = wrBits[(i+1)*2];			//f[^

			wrBits[(i+1)*2] = (wrBits[(i+1)*2] & 0x3D);		//bit1(SC)Lɂ
			wrBits[((i+1)*2)+1] = wrBits[((i+1)*2)+1] | 0x02;	//bit1(SC)Hɂ
			_temp1 = _org << (i+1);

		}

		wrBits[18] = (_adr * 8) | 0x24; //bit3,4ɃAhXZbg bit5(GATE)ON bit2(WR)Inactive
		wrBits[19] = wrBits[18] & 0x3B; //bit2(WR)ActiveɂB
		wrBits[20] = wrBits[18];	//bit2(WR)InactiveɂB
	
		ftStatus = FT_Write(ftHandle, wrBits, sizeof(wrBits), &BytesWritten);	//

		return;

	}

	void Send8254(D_8254 _send, unsigned short int _addr){

		SetWrite(_send.low, _addr);

		SetWrite(_send.high, _addr);

		return;
	}